# WIP 🚧🚧🚧
# TODO:
# - Mono Repos
# - tests
# - quality + LPS
# - vulnerabilities
# - secrets
# - metrics (do load test?)
# - ...

stages:
  - test
  - security
  - unit-tests
  - tests-report
  - build
  - deploy

#include:
#  - template: Code-Quality.gitlab-ci.yml
#include:
#  - template: Security/SAST.gitlab-ci.yml 
#include:
#  - template: Security/Secret-Detection.gitlab-ci.yml

include: 
  - '/templates/Code-Quality.gitlab-ci.yml'
  - '/templates/SAST.gitlab-ci.yml'
  - '/templates/Secret-Detection.gitlab-ci.yml'


# TODO: generate tests only if change
test-hello:
  image: golang:1.16
  stage: unit-tests
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
    - if: $CI_MERGE_REQUEST_IID
  artifacts:
    paths:
      - hello-report.xml
    expire_in: 1 week
  script:
    - apt update -y
    - apt install nodejs -y
    - cd hello
    - go get -u github.com/jstemmer/go-junit-report
    - GOOS=js GOARCH=wasm go test -exec="$(go env GOROOT)/misc/wasm/go_js_wasm_exec" -v 2>&1 | go-junit-report > ../hello-report.xml

test-morgen:
  image: golang:1.16
  stage: unit-tests
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
    - if: $CI_MERGE_REQUEST_IID
  artifacts:
    paths:
      - morgen-report.xml
    expire_in: 1 week
  script:
    - apt update -y
    - apt install nodejs -y
    - cd morgen
    - go get -u github.com/jstemmer/go-junit-report
    - GOOS=js GOARCH=wasm go test -exec="$(go env GOROOT)/misc/wasm/go_js_wasm_exec" -v 2>&1 | go-junit-report > ../morgen-report.xml

generate-tests-report:
  image: node:13.12-slim
  stage: unit-tests
  needs: ["test-hello", "test-morgen"] # it's possible on the same stage
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
    - if: $CI_MERGE_REQUEST_IID
  artifacts:
    when: always
    reports:
      junit: report.xml
  script:
    - npm install -g junit-report-merger
    - jrm ./report.xml "./*.xml"

build-index:
  stage: build
  image: registry.gitlab.com/tanuki-workshops/2022/docker-images/tinygo:latest
  #tags: [gitpod]
  artifacts:
    paths:
      - index.wasm
    expire_in: 1 week
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
    - if: $CI_MERGE_REQUEST_IID
  script: |    
    # -----------------------------
    # Building the index function
    # -----------------------------
    # using flags to inject CI variables
    tinygo build \
      -ldflags "-X main.ciProjectId=$CI_PROJECT_ID -X main.ciMergeRequestIid=$CI_MERGE_REQUEST_IID -X main.ciProjectPath=$CI_PROJECT_PATH -X main.ciCommitRefSlug=$CI_COMMIT_REF_SLUG" \
      -o index.wasm -target wasm ./index/main.go
    ls -lh *.wasm

build-hello:
  stage: build
  image: registry.gitlab.com/tanuki-workshops/2022/docker-images/tinygo:latest
  #tags: [gitpod]
  artifacts:
    paths:
      - hello.wasm
    expire_in: 1 week
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
    - if: $CI_MERGE_REQUEST_IID
  script: |
    # -----------------------------
    # Building the hello function
    # -----------------------------
    tinygo build -o hello.wasm -target wasm ./hello/main.go
    ls -lh *.wasm

build-morgen:
  stage: build
  image: registry.gitlab.com/tanuki-workshops/2022/docker-images/tinygo:latest
  #tags: [gitpod]
  artifacts:
    paths:
      - morgen.wasm
    expire_in: 1 week
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
    - if: $CI_MERGE_REQUEST_IID
  script: |    
    # -----------------------------
    # Building the morgen function
    # -----------------------------
    tinygo build -o morgen.wasm -target wasm ./morgen/main.go
    ls -lh *.wasm

deploy-hello:
  stage: deploy
  image: registry.gitlab.com/tanuki-workshops/2022/docker-images/galago-cli:latest
  #tags: [gitpod]
  # can start once the build is terminated (the jobs are not in the same stage)
  needs: ["build-hello"] 
  artifacts:
    paths:
      - hello.wasm
    expire_in: 1 week
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
      variables: 
        GALAGO_URL: "${GALAGO_URL_PROD}"
        GALAGO_TOKEN: "${GALAGO_TOKEN_PROD}"
    - if: $CI_MERGE_REQUEST_IID
      variables: 
        GALAGO_URL: "${GALAGO_URL_DEV}"
        GALAGO_TOKEN: "${GALAGO_TOKEN_DEV}"
  script: |    
    # -----------------------------
    # Deploy hello function
    # -----------------------------
    # you need to set GALAGO_URL and GALAGO_TOKEN
    galago -cmd=deploy -name=hello -wasm=hello.wasm -ver=${CI_COMMIT_REF_SLUG}
    echo "hello function (${CI_COMMIT_REF_SLUG}) deployed"
    galago -cmd=data

deploy-morgen:
  stage: deploy
  image: registry.gitlab.com/tanuki-workshops/2022/docker-images/galago-cli:latest
  #tags: [gitpod]
  # can start once the build is terminated (the jobs are not in the same stage)
  needs: ["build-morgen"] 
  artifacts:
    paths:
      - morgen.wasm
    expire_in: 1 week
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
      variables: 
        GALAGO_URL: "${GALAGO_URL_PROD}"
        GALAGO_TOKEN: "${GALAGO_TOKEN_PROD}"
    - if: $CI_MERGE_REQUEST_IID
      variables: 
        GALAGO_URL: "${GALAGO_URL_DEV}"
        GALAGO_TOKEN: "${GALAGO_TOKEN_DEV}"
  script: |
    # -----------------------------
    # Deploy hello function
    # -----------------------------
    # you need to set GALAGO_URL and GALAGO_TOKEN
    galago -cmd=deploy -name=morgen -wasm=morgen.wasm -ver=${CI_COMMIT_REF_SLUG}
    echo "morgen function (${CI_COMMIT_REF_SLUG}) deployed"
    galago -cmd=data

# Set dynamic environment URLs after a job finishes
# https://docs.gitlab.com/ee/ci/environments/#set-dynamic-environment-urls-after-a-job-finishes

deploy-index:
  stage: deploy
  image: registry.gitlab.com/tanuki-workshops/2022/docker-images/galago-cli:latest
  #tags: [gitpod]
  # can start once the build is terminated (the jobs are not in the same stage)
  needs: ["build-index", "deploy-morgen", "deploy-hello"]
  artifacts:
    paths:
      - index.wasm
    expire_in: 1 week
    reports:
      dotenv: deploy.env 
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
      variables: 
        GALAGO_URL: "${GALAGO_URL_PROD}"
        GALAGO_TOKEN: "${GALAGO_TOKEN_PROD}"
    - if: $CI_MERGE_REQUEST_IID
      variables: 
        GALAGO_URL: "${GALAGO_URL_DEV}"
        GALAGO_TOKEN: "${GALAGO_TOKEN_DEV}"
  environment:
    name: ${CI_PROJECT_NAME}-${CI_COMMIT_REF_NAME}
    url: $DYNAMIC_ENVIRONMENT_URL
    on_stop: remove-index-environment
    # TODO: check how to add rules in environment section
  script: |
    # In script, get the environment URL.
    echo "🖐️ ${GALAGO_URL}"
    DYNAMIC_ENVIRONMENT_URL="${GALAGO_URL}/functions/web/html/index/${CI_COMMIT_REF_SLUG}"
    echo "🖐️ ${DYNAMIC_ENVIRONMENT_URL}"
    # Add the value to a dotenv file.
    echo "DYNAMIC_ENVIRONMENT_URL=$DYNAMIC_ENVIRONMENT_URL" >> deploy.env 
    # -----------------------------
    # Deploy index function
    # -----------------------------
    # you need to set GALAGO_URL and GALAGO_TOKEN
    galago -cmd=deploy -name=index -wasm=index.wasm -ver=${CI_COMMIT_REF_SLUG}
    # TODO: don't activate when $CI_COMMIT_BRANCH == "main"
    # galago -cmd=activate -name=index -ver=${CI_COMMIT_REF_SLUG}
    echo "index function (${CI_COMMIT_REF_SLUG}) deployed"
    galago -cmd=data

remove-index-environment:
  stage: deploy
  image: registry.gitlab.com/tanuki-workshops/2022/docker-images/galago-cli:latest
  #tags: [gitpod]
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
      variables: 
        GALAGO_URL: "${GALAGO_URL_PROD}"
        GALAGO_TOKEN: "${GALAGO_TOKEN_PROD}"
      when: never
    - if: $CI_MERGE_REQUEST_IID
      variables: 
        GALAGO_URL: "${GALAGO_URL_DEV}"
        GALAGO_TOKEN: "${GALAGO_TOKEN_DEV}"
      when: manual
  environment:
    name: ${CI_PROJECT_NAME}-${CI_COMMIT_REF_NAME}
    action: stop
  allow_failure: true
  script: |
    # -----------------------------
    # Remove index function
    # -----------------------------
    galago -cmd=remove -name=index -ver=${CI_COMMIT_REF_SLUG}
    echo "index function (${CI_COMMIT_REF_SLUG}) deleted"

